SystemOrganization addCategory: #'TP2-TADP'!
SystemOrganization addCategory: #'TP2-TADP-Fixture'!
SystemOrganization addCategory: #'TP2-TADP-Tests'!

TestCase subclass: #ClassCreatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP-Tests'!

!ClassCreatorTest commentStamp: '<historical>' prior: 0!
A ClassCreatorTest is a test class for testing the behavior of ClassCreator!

!ClassCreatorTest methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/4/2013 00:00'!
test_addInstanceVariables_should_add_them_to_the_result_class
	| dogClass |
	
	dogClass := (ClassCreator withName: #Dog) addInstanceVariables: { 'weight'. 'name' } ; create.
	
	self assert: dogClass instVarNames equals: { 'weight'. 'name' }! !

!ClassCreatorTest methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/4/2013 00:36'!
test_addMethods_should_add_them_to_the_result_class
	| employeeClass |
	
	employeeClass := (ClassCreator withName: #Employee)
		addMessage: #isHappy withImplementation: 'isHappy ^ false' ;
		create.
		
	self assert: 
		(employeeClass methodDictionary at: #isHappy) sourceCode 
	equals: 
		'isHappy ^ false'! !

!ClassCreatorTest methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/3/2013 23:46'!
test_withName_should_create_an_empty_class
	| newClass |

	newClass := (ClassCreator withName: #NuevaClase) create.

	self assert: newClass name equals: #NuevaClase! !

TestCase subclass: #RefactorsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP-Tests'!

!RefactorsTest methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 4/30/2013 01:31'!
setUp
	MetaUtil recreateCategory: 'TP2-TADP-Fixture'! !

TestCase subclass: #TheBlobTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP-Tests'!

!TheBlobTest commentStamp: '<historical>' prior: 0!
A TheBlobTest is a test class for testing the behavior of TheBlob!

!TheBlobTest methodsFor: 'helpers' stamp: 'FedericoAloi 5/3/2013 00:11'!
blobCanBePerformedFor: someAttributesWithUsages equals: expectedResult
	self assert: (TheBlob new canBePerformedFor: someAttributesWithUsages) equals: expectedResult! !

!TheBlobTest methodsFor: 'can be refactored' stamp: 'FedericoAloi 5/3/2013 00:16'!
test_one_attribute_with_one_usage_cant_be_refactored
	self blobCanBePerformedFor:  	
	{ 
		AttributeWithUsages forAttribute: 'nombre' usages: { #nombreCompleto }.
	}
	equals: false! !

!TheBlobTest methodsFor: 'can be refactored' stamp: 'FedericoAloi 5/3/2013 00:23'!
test_two_attributes_with_one_common_usage_cant_be_refactored
	self blobCanBePerformedFor: 	
	{ 
		AttributeWithUsages forAttribute: 'nombre' usages: { #nombreCompleto. #presentate }.
		AttributeWithUsages forAttribute: 'apellido' usages: { #nombreCompleto }.		
	}
	equals: false! !

!TheBlobTest methodsFor: 'can be refactored' stamp: 'FedericoAloi 5/3/2013 00:24'!
test_two_attributes_with_one_different_usage_each_can_be_refactored
	self blobCanBePerformedFor: 
	{ 
		AttributeWithUsages forAttribute: 'nombre' usages: { #nombreCompleto }.
		AttributeWithUsages forAttribute: 'edad' usages: { #esMayorDeEdad }.		
	}	
	equals: true! !

!TheBlobTest methodsFor: 'can be refactored' stamp: 'FedericoAloi 5/3/2013 00:20'!
test_two_attributes_with_the_same_two_usages_cant_be_refactored
	self blobCanBePerformedFor: 	
	{ 
		AttributeWithUsages forAttribute: 'nombre' usages: { #nombreCompleto. #presentate }.
		AttributeWithUsages forAttribute: 'apellido' usages: { #nombreCompleto. #presentate }.		
	}
	equals: false! !

!TheBlobTest methodsFor: 'can be refactored' stamp: 'FedericoAloi 5/3/2013 00:26'!
test_two_pairs_of_attributes_with_the_same_two_usages_can_be_refactored
	self blobCanBePerformedFor:	
	{ 
		AttributeWithUsages forAttribute: 'nombre' usages: { #nombreCompleto. #presentate }.
		AttributeWithUsages forAttribute: 'apellido' usages: { #nombreCompleto. #presentate }.		
		AttributeWithUsages forAttribute: 'edad' usages: { #esMayorDeEdad. #puedeVotar }.
		AttributeWithUsages forAttribute: 'nacionalidad' usages: { #esMayorDeEdad. #puedeVotar }.		
	}
	equals: true! !

Object subclass: #AttributeWithUsages
	instanceVariableNames: 'attribute usages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP'!

!AttributeWithUsages class methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/2/2013 00:06'!
forAttribute: anAttributeName usages: someUsages
	^self new attribute: anAttributeName ; usages: someUsages ; yourself! !

!AttributeWithUsages methodsFor: 'accessing' stamp: 'FedericoAloi 5/2/2013 00:08'!
attribute
	^ attribute! !

!AttributeWithUsages methodsFor: 'accessing' stamp: 'FedericoAloi 5/2/2013 00:08'!
attribute: anObject
	attribute := anObject! !

!AttributeWithUsages methodsFor: 'accessing' stamp: 'FedericoAloi 5/2/2013 00:07'!
usages
	^ usages! !

!AttributeWithUsages methodsFor: 'accessing' stamp: 'FedericoAloi 5/2/2013 00:07'!
usages: anObject
	usages := anObject! !

Object subclass: #ClassCreator
	instanceVariableNames: 'clazz'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP'!

!ClassCreator class methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/4/2013 00:56'!
withName: aClassName 
	^self new 
		clazz: (Object subclass: aClassName) ; 
		yourself! !

!ClassCreator methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/4/2013 00:59'!
addInstanceVariables: someInstanceVariableNames 
	someInstanceVariableNames do: [ :aName | self clazz addInstVarNamed: aName ]! !

!ClassCreator methodsFor: 'accessing' stamp: 'FedericoAloi 5/4/2013 00:59'!
clazz
	^ clazz! !

!ClassCreator methodsFor: 'accessing' stamp: 'FedericoAloi 5/4/2013 00:59'!
clazz: anObject
	clazz := anObject! !

!ClassCreator methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/4/2013 00:59'!
create
	^self clazz! !

Object subclass: #InteractionGroup
	instanceVariableNames: 'methods attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP'!

!InteractionGroup class methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/3/2013 00:50'!
withAttributes: someAttributes usages: someUsages
	^self new addAttributes: someAttributes ; addMethods: someUsages ; yourself! !

!InteractionGroup methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/2/2013 01:41'!
addAttribute: anAttribute
	self attributes add: anAttribute ! !

!InteractionGroup methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/3/2013 00:50'!
addAttributes: someAttributes
	someAttributes do: [ :anAttribute | self addAttribute: anAttribute ]! !

!InteractionGroup methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/2/2013 01:40'!
addMethods: someMethods
	self methods addAll: someMethods ! !

!InteractionGroup methodsFor: 'accessing' stamp: 'FedericoAloi 5/2/2013 01:42'!
attributes
	^ attributes! !

!InteractionGroup methodsFor: 'accessing' stamp: 'FedericoAloi 5/2/2013 01:42'!
attributes: anObject
	attributes := anObject! !

!InteractionGroup methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/2/2013 01:39'!
initialize
	self methods: Set new.
	self attributes: Set new.! !

!InteractionGroup methodsFor: 'accessing' stamp: 'FedericoAloi 5/2/2013 01:42'!
methods
	^ methods! !

!InteractionGroup methodsFor: 'accessing' stamp: 'FedericoAloi 5/2/2013 01:42'!
methods: anObject
	methods := anObject! !

Object subclass: #MetaUtil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP-Tests'!

!MetaUtil class methodsFor: 'as yet unclassified' stamp: 'Demian 9/8/2012 00:29'!
recreateCategory: categoryName
	(SystemOrganization listAtCategoryNamed: categoryName) do: [ :typeName | Smalltalk removeClassNamed: typeName ].
	SystemOrganization removeCategory: categoryName.
	FileStream fileIn: categoryName , '.st'.
	SystemOrganization sortCategories! !

Object subclass: #NamedPerson
	instanceVariableNames: 'name surname'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP-Fixture'!

!NamedPerson methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/3/2013 00:35'!
fullName
	^name , ' ', surname! !

Object subclass: #TheBlob
	instanceVariableNames: 'clazz interactionGroups'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP'!

!TheBlob class methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/3/2013 00:41'!
for: clazz
	^self new clazz: clazz ; createInteractionGroups ; yourself! !

!TheBlob methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/3/2013 01:26'!
addInstanceVariables: someInstanceVariables to: aClass
	someInstanceVariables do: [ :anInstanceVariable | aClass addInstVarNamed: anInstanceVariable ]! !

!TheBlob methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/2/2013 02:32'!
attributes
	^self clazz instVarNames ! !

!TheBlob methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/2/2013 02:31'!
attributesWithUsages
	^self attributes collect: [ :anAttribute | AttributeWithUsages forAttribute: anAttribute usages: (self usagesOf: anAttribute) ]! !

!TheBlob methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/2/2013 01:43'!
canBePerformedFor: someAttributesWithUsages
	self createInteractionGroupsFor: someAttributesWithUsages.
	^self interactionGroups size > 1! !

!TheBlob methodsFor: 'accessing' stamp: 'FedericoAloi 5/2/2013 02:30'!
clazz
	^ clazz! !

!TheBlob methodsFor: 'accessing' stamp: 'FedericoAloi 5/2/2013 02:30'!
clazz: anObject
	clazz := anObject! !

!TheBlob methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/3/2013 00:55'!
createAndAddInteractionGroup
	| newInteractionGroup |
	newInteractionGroup := InteractionGroup new.
	self interactionGroups add: newInteractionGroup.
	^newInteractionGroup! !

!TheBlob methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/3/2013 00:57'!
createInteractionGroups
	self createInteractionGroupsFor: self attributesWithUsages! !

!TheBlob methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/2/2013 01:46'!
createInteractionGroupsFor: someAttributesWithUsages
	someAttributesWithUsages do: [ :anAttributeWithUsages | 
			(self findOrCreateInteractionGroupFor: anAttributeWithUsages)
				addAttribute: anAttributeWithUsages attribute;
				addMethods: anAttributeWithUsages usages 
	]! !

!TheBlob methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/3/2013 23:38'!
createNewClassFrom: anInteractionGroup named: newClassName
	self splitClassUsing: anInteractionGroup.

	^ (ClassCreator withName: newClassName)
		addInstanceVariables: anInteractionGroup attributes ;
		addMethods: (anInteractionGroup methods collect: [ :aSelector | self clazz >> aSelector ]) ;
		create
! !

!TheBlob methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/3/2013 00:55'!
findOrCreateInteractionGroupFor: anAttributeWithUsages
	^ self interactionGroups 
		detect: [ :anInteractionGroup | anInteractionGroup methods includesAny: anAttributeWithUsages usages ]
		ifNone: [self createAndAddInteractionGroup]! !

!TheBlob methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/2/2013 01:36'!
initialize
	self interactionGroups: Bag new! !

!TheBlob methodsFor: 'accessing' stamp: 'FedericoAloi 5/2/2013 01:37'!
interactionGroups
	^ interactionGroups! !

!TheBlob methodsFor: 'accessing' stamp: 'FedericoAloi 5/2/2013 01:37'!
interactionGroups: anObject
	interactionGroups := anObject! !

!TheBlob methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/3/2013 01:14'!
removeAttributes: someAttributes
	someAttributes do: [ :anAttribute | 	self clazz removeInstVarNamed: anAttribute ]! !

!TheBlob methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 5/2/2013 02:30'!
usagesOf: anAttribute
	^self clazz whichSelectorsAccess: anAttribute ! !

Object subclass: #TheInterceptor
	instanceVariableNames: 'afterCode beforeCode theClasses theMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP'!

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 19:18'!
addACategory: unaCategoriaString
	theClasses addAll: (Object subclasses select: [ :aClass | aClass category == (unaCategoriaString asSymbol)]).

! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 18:28'!
addClasses: anString
	| classesNames |
	classesNames := anString subStrings: ' '.
	theClasses addAll: (classesNames collect: [ :name | Compiler evaluate: name]).! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 20:38'!
agregarCodigo
	| codes |
	codes := self getTheMethods collect: [ :method | self getBeforeCode , method sourceCode, self getAfterCode ].
	^codes! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 17:45'!
getAfterCode
	
	^ afterCode! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 17:47'!
getBeforeCode
	
	^ beforeCode! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 18:24'!
getTheClasses
	
	^ theClasses! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 20:38'!
getTheMethods
	
	^ theMethods! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 19:27'!
initialize 
	theClasses := Bag new.
	theMethods := Bag new.! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 20:35'!
methodsBeginWith: anString
	| allMethods |
	allMethods := (theClasses collect: [ :aClass | aClass methods]).
	^ allMethods gather: [ :arrayMethods | arrayMethods select:  [:aMethod | (aMethod selector beginsWith: anString asSymbol)]].! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 20:37'!
selectAccessors
	theMethods addAll: (self methodsBeginWith: 'set').
	theMethods addAll: (self methodsBeginWith: 'get').! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 20:36'!
selectMethodsBeginWith: anString
	theMethods addAll: (self methodsBeginWith: anString)! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 17:46'!
setAfterCode: anObject
	
	afterCode := anObject! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 17:47'!
setBeforeCode: anObject
	
	beforeCode := anObject! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 18:23'!
setTheClasses: anObject
	
	theClasses := anObject! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 20:38'!
setTheMethods: anObject
	
	theMethods := anObject! !
